e342974dc0c2d99a0ad4e93743e94f23cb9de63f
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .dotest working files, use the command
  18git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.  You must be in the top
  22directory of your project to start (or continue) a rebase.
  23
  24Example:       git-rebase master~1 topic
  25
  26        A---B---C topic                   A'\''--B'\''--C'\'' topic
  27       /                   -->           /
  28  D---E---F---G master          D---E---F---G master
  29'
  30
  31SUBDIRECTORY_OK=Yes
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest=$GIT_DIR/.dotest-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget to use git add?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        cmt=`cat $dotest/current`
  63        if ! git diff-index --quiet HEAD
  64        then
  65                if ! git-commit -C "$cmt"
  66                then
  67                        echo "Commit failed, please do not call \"git commit\""
  68                        echo "directly, but instead do one of the following: "
  69                        die "$RESOLVEMSG"
  70                fi
  71                printf "Committed: %0${prec}d " $msgnum
  72        else
  73                printf "Already applied: %0${prec}d " $msgnum
  74        fi
  75        git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  76
  77        prev_head=`git rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat $dotest/cmt.$1)"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git rev-parse --verify HEAD)
  90        cmt_name=$(git symbolic-ref HEAD)
  91        msgnum=$(cat $dotest/msgnum)
  92        end=$(cat $dotest/end)
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                git rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118finish_rb_merge () {
 119        if test -f "$dotest/stash"
 120        then
 121                stash=$(cat "$dotest/stash")
 122                git stash apply --index "$stash"
 123        fi
 124        rm -r "$dotest"
 125        echo "All done."
 126}
 127
 128read_stash () {
 129        if test -f "$1"
 130        then
 131                cat "$1"
 132        fi
 133}
 134unstash_and_exit () {
 135        err=$?
 136        if test -f "$1" && test $err = 0
 137        then
 138                git stash apply --index "$1"
 139        fi
 140        exit $err
 141}
 142
 143is_interactive () {
 144        test -f "$dotest"/interactive ||
 145        while case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
 146        do
 147                shift
 148        done && test -n "$1"
 149}
 150
 151is_interactive "$@" && exec git-rebase--interactive "$@"
 152
 153while case "$#" in 0) break ;; esac
 154do
 155        case "$1" in
 156        --continue)
 157                git diff-files --quiet || {
 158                        echo "You must edit all merge conflicts and then"
 159                        echo "mark them as resolved using git add"
 160                        exit 1
 161                }
 162                if test -d "$dotest"
 163                then
 164                        prev_head="`cat $dotest/prev_head`"
 165                        end="`cat $dotest/end`"
 166                        msgnum="`cat $dotest/msgnum`"
 167                        onto="`cat $dotest/onto`"
 168                        continue_merge
 169                        while test "$msgnum" -le "$end"
 170                        do
 171                                call_merge "$msgnum"
 172                                continue_merge
 173                        done
 174                        finish_rb_merge
 175                        exit
 176                fi
 177                stash=$(read_stash ".dotest/stash")
 178                git am --resolved --3way --resolvemsg="$RESOLVEMSG"
 179                unstash_and_exit "$stash"
 180                ;;
 181        --skip)
 182                if test -d "$dotest"
 183                then
 184                        git rerere clear
 185                        prev_head="`cat $dotest/prev_head`"
 186                        end="`cat $dotest/end`"
 187                        msgnum="`cat $dotest/msgnum`"
 188                        msgnum=$(($msgnum + 1))
 189                        onto="`cat $dotest/onto`"
 190                        while test "$msgnum" -le "$end"
 191                        do
 192                                call_merge "$msgnum"
 193                                continue_merge
 194                        done
 195                        finish_rb_merge
 196                        exit
 197                fi
 198                stash=$(read_stash ".dotest/stash")
 199                git am -3 --skip --resolvemsg="$RESOLVEMSG"
 200                unstash_and_exit "$stash"
 201                ;;
 202        --abort)
 203                git rerere clear
 204                if test -d "$dotest"
 205                then
 206                        if test -f "$dotest/stash"
 207                        then
 208                                stash=$(cat "$dotest/stash")
 209                        fi
 210                        rm -r "$dotest"
 211                elif test -d .dotest
 212                then
 213                        if test -f ".dotest/stash"
 214                        then
 215                                stash=$(cat ".dotest/stash")
 216                        fi
 217                        rm -r .dotest
 218                else
 219                        die "No rebase in progress?"
 220                fi
 221                git reset --hard ORIG_HEAD
 222                test -z "$stash" || git stash apply --index "$stash"
 223                exit
 224                ;;
 225        --onto)
 226                test 2 -le "$#" || usage
 227                newbase="$2"
 228                shift
 229                ;;
 230        -M|-m|--m|--me|--mer|--merg|--merge)
 231                do_merge=t
 232                ;;
 233        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 234                --strateg=*|--strategy=*|\
 235        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 236                case "$#,$1" in
 237                *,*=*)
 238                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 239                1,*)
 240                        usage ;;
 241                *)
 242                        strategy="$2"
 243                        shift ;;
 244                esac
 245                do_merge=t
 246                ;;
 247        -v|--verbose)
 248                verbose=t
 249                ;;
 250        --whitespace=*)
 251                git_am_opt="$git_am_opt $1"
 252                ;;
 253        -C*)
 254                git_am_opt="$git_am_opt $1"
 255                ;;
 256        -*)
 257                usage
 258                ;;
 259        *)
 260                break
 261                ;;
 262        esac
 263        shift
 264done
 265
 266# Make sure we do not have .dotest
 267if test -z "$do_merge"
 268then
 269        if mkdir .dotest
 270        then
 271                rmdir .dotest
 272        else
 273                echo >&2 '
 274It seems that I cannot create a .dotest directory, and I wonder if you
 275are in the middle of patch application or another rebase.  If that is not
 276the case, please rm -fr .dotest and run me again.  I am stopping in case
 277you still have something valuable there.'
 278                exit 1
 279        fi
 280else
 281        if test -d "$dotest"
 282        then
 283                die "previous dotest directory $dotest still exists." \
 284                        'try git-rebase < --continue | --abort >'
 285        fi
 286fi
 287
 288# The upstream head must be given.  Make sure it is valid.
 289upstream_name="$1"
 290upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 291    die "invalid upstream $upstream_name"
 292
 293# Make sure the branch to rebase onto is valid.
 294onto_name=${newbase-"$upstream_name"}
 295onto=$(git rev-parse --verify "${onto_name}^0") || exit
 296
 297# The tree must be clean enough for us to create a stash
 298stash=$(git stash create) || exit
 299if test -n "$stash"
 300then
 301        echo >&2 "Stashed away your working tree changes"
 302fi
 303
 304# If a hook exists, give it a chance to interrupt
 305if test -x "$GIT_DIR/hooks/pre-rebase"
 306then
 307        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 308                echo >&2 "The pre-rebase hook refused to rebase."
 309                test -z "$stash" || git stash apply --index "$stash"
 310                exit 1
 311        }
 312fi
 313
 314# If the branch to rebase is given, first switch to it.
 315case "$#" in
 3162)
 317        branch_name="$2"
 318        git-checkout "$2" || {
 319                test -z "$stash" || git stash apply --index "$stash"
 320                usage
 321        }
 322        ;;
 323*)
 324        if branch_name=`git symbolic-ref -q HEAD`
 325        then
 326                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 327        else
 328                branch_name=HEAD ;# detached
 329        fi
 330        ;;
 331esac
 332branch=$(git rev-parse --verify "${branch_name}^0") || exit
 333
 334# Now we are rebasing commits $upstream..$branch on top of $onto
 335
 336# Check if we are already based on $onto with linear history,
 337# but this should be done only when upstream and onto are the same.
 338mb=$(git merge-base "$onto" "$branch")
 339if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 340        # linear history?
 341        ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
 342then
 343        echo >&2 "Current branch $branch_name is up to date."
 344        test -z "$stash" || git stash apply --index "$stash"
 345        exit 0
 346fi
 347
 348if test -n "$verbose"
 349then
 350        echo "Changes from $mb to $onto:"
 351        # We want color (if set), but no pager
 352        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 353fi
 354
 355# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
 356echo "First, rewinding head to replay your work on top of it..."
 357git-reset --hard "$onto"
 358
 359# If the $onto is a proper descendant of the tip of the branch, then
 360# we just fast forwarded.
 361if test "$mb" = "$branch"
 362then
 363        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 364        test -z "$stash" || git stash apply --index "$stash"
 365        exit 0
 366fi
 367
 368if test -z "$do_merge"
 369then
 370        git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
 371        git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
 372        err=$?
 373
 374        if test $err = 0
 375        then
 376                test -z "$stash" || git stash apply --index "$stash"
 377                exit
 378        else
 379                test -z "$stash" || echo "$stash" >.dotest/stash
 380                exit $err
 381        fi
 382fi
 383
 384# start doing a rebase with git-merge
 385# this is rename-aware if the recursive (default) strategy is used
 386
 387mkdir -p "$dotest"
 388echo "$onto" > "$dotest/onto"
 389echo "$onto_name" > "$dotest/onto_name"
 390prev_head=`git rev-parse HEAD^0`
 391echo "$prev_head" > "$dotest/prev_head"
 392test -z "$stash" || echo "$stash" >"$dotest/stash"
 393
 394msgnum=0
 395for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
 396do
 397        msgnum=$(($msgnum + 1))
 398        echo "$cmt" > "$dotest/cmt.$msgnum"
 399done
 400
 401echo 1 >"$dotest/msgnum"
 402echo $msgnum >"$dotest/end"
 403
 404end=$msgnum
 405msgnum=1
 406
 407while test "$msgnum" -le "$end"
 408do
 409        call_merge "$msgnum"
 410        continue_merge
 411done
 412
 413finish_rb_merge